Index: /trunk/src/Makefile.am
===================================================================
--- /trunk/src/Makefile.am	(revision 6138)
+++ /trunk/src/Makefile.am	(revision 6139)
@@ -25,5 +25,5 @@
                        lib/gui/gl_gui/libORXglgui.a \
                        lib/shell/libORXshell.a \
-                       lib/network/libORXnet.a 
+                       lib/network/libORXnet.a
 
 orxonox_LDADD = util/libORXutils.a \
@@ -49,4 +49,5 @@
                   story_entities/campaign.cc \
                   story_entities/world.cc \
+                  story_entities/network_world.cc \
                   world_entities/world_entity.cc \
                   world_entities/camera.cc \
@@ -85,4 +86,5 @@
                   world_entities/space_ships/space_ship.cc \
                   world_entities/space_ships/helicopter.cc \
+                  world_entities/spawning_point.cc \
                   subprojects/benchmark.cc
 
@@ -94,4 +96,5 @@
                  story_entities/campaign.h \
                  story_entities/world.h \
+                 story_entities/network_world.h \
                  world_entities/world_entity.h \
                  world_entities/camera.h \
@@ -130,4 +133,5 @@
                  world_entities/space_ships/space_ship.h \
                  world_entities/space_ships/helicopter.h \
+                 world_entities/spawning_point.h \
                  defs/stdincl.h \
                  defs/stdlibincl.h \
Index: /trunk/src/defs/class_id.h
===================================================================
--- /trunk/src/defs/class_id.h	(revision 6138)
+++ /trunk/src/defs/class_id.h	(revision 6139)
@@ -147,4 +147,5 @@
   CL_SPACE_SHIP                 =    0x0000020a,
   CL_HELICOPTER                 =    0x0000020b,
+  CL_SPAWNING_POINT             =    0x0000020b,
 
   CL_TURRET_POWER_UP            =    0x00000211,
@@ -230,5 +231,5 @@
 
   // network stuff (range from 0x00000b00 to 0x00000bff)
-  CL_DATA_STREAM                =    0x00b01000,
+  CL_DATA_STREAM                =    0x00b01b00,
   CL_NETWORK_STREAM             =    0x00000b01,
   CL_NETWORK_PROTOCOL           =    0x00000b02,
@@ -236,4 +237,6 @@
   CL_SERVER_SOCKET              =    0X00000b04,
   CL_CONNECTION_MONITOR         =    0x00000b05,
+  CL_HANDSHAKE                  =    0x00000b06,
+  CL_ENTITY_MANAGER             =    0x00000b07,
 
 
Index: /trunk/src/lib/graphics/importer/texture.cc
===================================================================
--- /trunk/src/lib/graphics/importer/texture.cc	(revision 6138)
+++ /trunk/src/lib/graphics/importer/texture.cc	(revision 6139)
@@ -19,4 +19,6 @@
 
 #include "debug.h"
+#include "compiler.h"
+#include <math.h>
 
 // INCLUDING SDL_Image
@@ -37,4 +39,5 @@
   this->texture = 0;
   this->image = NULL;
+  this->priority = 0.5;
 
   if (imageName != NULL)
@@ -177,5 +180,5 @@
  * @returns a !!new!! Surface, that is loadable by openGL.
  */
-SDL_Surface* Texture::prepareSurface(SDL_Surface* surface, bool& hasAlpha)
+SDL_Surface* Texture::prepareSurface(SDL_Surface* surface, bool& hasAlpha) const
 {
   PRINTF(4)("Loading texture to OpenGL-Environment.\n");
@@ -237,5 +240,5 @@
  * @returns The ID of the texture.
  */
-GLuint Texture::loadTexToGL (const SDL_Surface* surface)
+GLuint Texture::loadTexToGL (const SDL_Surface* surface) const
 {
 //   if (this->texture != 0 && glIsTexture(this->texture))
@@ -243,5 +246,10 @@
 //   this->texture = 0;
 
-  GLuint texture;
+  int      errorCode = 0;           //!< the error code for the texture loading functions
+  GLuint   texture;                 //!< the OpenGL texture handle
+  int      mipmapLevel = 0;         //!< the maximum mipmap level for this texture
+  int      mipmapWidth = 0;         //!< the width of the mipmap
+  int      mipmapHight = 0;         //!< the height of the mipmap
+
 
   if (surface == NULL)
@@ -251,7 +259,13 @@
   glGenTextures(1, &texture);
   glBindTexture(GL_TEXTURE_2D, texture);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
-  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
-  // build the Texture
+
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, /*GL_LINEAR*/ GL_LINEAR_MIPMAP_LINEAR);
+  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, /*GL_LINEAR*/ GL_LINEAR);
+  /* control the mipmap levels */
+  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MIN_LOD, -100);
+  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MAX_LOD, 0);
+  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_PRIORITY, this->priority);
+
+  /* build the Texture  OpenGL V >= 1.1 */
   glTexImage2D(GL_TEXTURE_2D,
                0,
@@ -262,13 +276,38 @@
                GL_UNSIGNED_BYTE,
                surface->pixels);
-  // build the MipMaps
-  gluBuild2DMipmaps(GL_TEXTURE_2D,
-                    GL_RGBA,
-                    surface->w,
-                    surface->h,
-                    GL_RGBA,
-                    GL_UNSIGNED_BYTE,
-                    surface->pixels);
+
+  // build the MipMaps automaticaly
+  errorCode = gluBuild2DMipmaps(GL_TEXTURE_2D,
+                                GL_RGBA,
+                                surface->w,
+                                surface->h,
+                                GL_RGBA,
+                                GL_UNSIGNED_BYTE,
+                                surface->pixels
+                               );
+  if(unlikely(errorCode != 0))
+    PRINTF(1)("Error while loading texture, gluBuild2DMipmaps returned %i\n", errorCode);
+
+#define max(a,b) (a>b)?a:b
+  mipmapLevel = (int)(log2f(max(surface->w, surface->h)));
+#undef max
+  PRINTF(5)("Built the texture mipmpaps, got: %i levels of detail\n", mipmapLevel);
+
+  /* now actualy load the mipmaps into the graphics memory */
+  glGetTexLevelParameteriv(GL_PROXY_TEXTURE_2D, 1, GL_TEXTURE_WIDTH, &mipmapWidth);
+  glGetTexLevelParameteriv(GL_PROXY_TEXTURE_2D, 1, GL_TEXTURE_WIDTH, &mipmapHight);
+  PRINTF(5)(" Mipmap at level %i has a %ix%i resolution\n", 1, mipmapWidth, mipmapHight);
+  glTexImage2D(GL_PROXY_TEXTURE_2D,
+               1,
+               GL_RGBA,
+               mipmapWidth, mipmapHight,
+               0,
+               GL_RGBA,
+               GL_UNSIGNED_BYTE,
+               NULL
+               );
+
   glBindTexture(GL_TEXTURE_2D, 0);
   return texture;
 }
+
Index: /trunk/src/lib/graphics/importer/texture.h
===================================================================
--- /trunk/src/lib/graphics/importer/texture.h	(revision 6138)
+++ /trunk/src/lib/graphics/importer/texture.h	(revision 6139)
@@ -39,6 +39,6 @@
 
       // Utility functionality:
-      static SDL_Surface* prepareSurface(SDL_Surface* input, bool& hasAlpha);
-      static GLuint loadTexToGL (const SDL_Surface* surface);
+      SDL_Surface* prepareSurface(SDL_Surface* input, bool& hasAlpha) const;
+      GLuint loadTexToGL (const SDL_Surface* surface) const;
 
     protected:
@@ -53,4 +53,5 @@
       bool             bAlpha;             //!< if the texture has an alpha channel.
       SDL_Surface*     image;              //!< The SDL_Surfce that stores the Texture on it.
+      GLclampf         priority;           //!< the priority of the current texture (used for garphics cards with limited mem)
 
       static bool      texturesEnabled;    //!< If the Textures are enabled.
Index: /trunk/src/lib/network/Makefile.am
===================================================================
--- /trunk/src/lib/network/Makefile.am	(revision 6138)
+++ /trunk/src/lib/network/Makefile.am	(revision 6139)
@@ -11,5 +11,9 @@
                       data_stream.cc \
                       network_protocol.cc \
-		      server_socket.cc
+		      server_socket.cc \
+		      handshake.cc \
+		      network_game_manager.cc \
+		      converter.cc
+
 
 
@@ -22,4 +26,8 @@
                  data_stream.h \
                  network_protocol.h \
-		 server_socket.h
+		 server_socket.h \
+		 handshake.h \
+		 network_game_manager.h \
+		 converter.h
 
+
Index: /trunk/src/lib/network/converter.cc
===================================================================
--- /trunk/src/lib/network/converter.cc	(revision 6139)
+++ /trunk/src/lib/network/converter.cc	(revision 6139)
@@ -0,0 +1,214 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Wuest
+   co-programmer: ...
+*/
+
+
+/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
+   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
+*/
+#define DEBUG_MODULE_NETWORK
+
+/* include your own header */
+#include "converter.h"
+
+
+/* using namespace std is default, this needs to be here */
+using namespace std;
+
+/*!
+ * Standard constructor
+ */
+Converter::Converter()
+{
+  /* set the class id for the base object */
+  //this->setClassID(CL_ENTITY_MANAGER, "EntityManager");
+}
+
+/*!
+ * Standard destructor
+ */
+Converter::~Converter()
+{
+}
+
+const int sgnadd = 128; // = 2^7
+
+/*!
+ * Converts an int into a byte-array
+ * @remarks: The int is stored in big-endian
+ * @param x: The int which is to convert
+ * @return: A byte-array that accords the given int value
+ */
+byte* Converter::intToByteArray(int x)
+{
+  const int mod = 256; // = 2^8
+  
+  
+  byte* result = new byte[INTSIZE];
+  int sgn;
+  if (x >= 0)
+    sgn = 1;
+  else
+  {
+    sgn = -1;
+    x = -x;
+  }
+  
+  for (int i = 0; i < INTSIZE; i++)
+  {
+    result[i] = x % mod;
+    x /= mod;
+  }
+  
+  if (sgn == -1)
+    result[INTSIZE - 1] += sgnadd;
+  
+  
+  return result;
+}
+
+/*!
+ * Converts a byte-array into an int
+ * @param a: The byte-array which is to convert
+ * @return: An int that accords the given byte-array
+ */
+int Converter::byteArrayToInt(byte* a)
+{
+  int mult = 1;
+  const int step = 256; // = 2 ^ 8
+  int result = 0;
+  for (int i = 0; i < INTSIZE - 1; i++)
+  {
+    result += a[i] * mult;
+    mult *= step;
+  }
+  
+  printf("tara: %i", result);
+  
+  if (a[INTSIZE - 1] >= sgnadd)
+  {
+    result += (a[INTSIZE - 1] - sgnadd) * mult;
+    result *= -1;
+  }
+  else
+    result += a[INTSIZE - 1] * mult;
+  
+  return result;
+}
+
+/*char* Converter::floatToBinString(float x)
+{
+  char* result = new char[200];
+  int pos = 0;
+  
+  int h = (int)x;
+  if (h > x)
+    h--;
+  x -= h;
+  
+  
+  while (h > 0 && pos < 200)
+  {
+    //printf("%i ", pos);
+    
+    if (h % 2 == 1)
+    {
+      result[pos] = '1';
+      h -= 1;
+    }
+    else
+      result[pos] = '0';
+    pos++;
+    h /= 2;
+  }
+  
+  //printf("x = %f\n", x);
+  
+  
+  //invert
+  for (int i = 0; i < pos / 2; i++)
+  {
+    char temp = result[i];
+    result[i] = result[pos - 1 - i];
+    result[pos - 1 - i] = temp;
+  }
+  
+  
+  result[pos++] = '.';
+  float sub = 0.5;
+  while (x > 0 && pos < 200)
+  {
+    //printf("%i ", pos);
+    
+    if (x >= sub)
+    {
+      result[pos] = '1';
+      x -= sub;
+    }
+    else
+      result[pos] = '0';
+    pos++;
+    sub /= 2;
+  }
+  
+  
+  return result;
+}*/
+
+char* Converter::floatToBinString(float x)
+{
+  char* result = new char[200];
+  int pos = 0;
+  
+  float sub = 1;
+  while (sub < x)
+    sub *= 2;
+  
+  //printf("sub = %f\n", sub);
+  
+  //while (sub >= 1 && pos < 200)
+  while ((x > 0 || sub >= 1) && pos < 200)
+  {
+    if (x >= sub)
+    {
+      result[pos] = '1';
+      x -= sub;
+    }
+    else
+      result[pos] = '0';
+    pos++;
+    sub /= 2;
+    
+    if (sub == 0.5f)
+      result[pos++] = '.';
+  }
+  
+  /*result[pos++] = '.';
+  sub = 0.5;
+  while (x > 0 && pos < 200)
+  {
+    if (x >= sub)
+    {
+      result[pos] = '1';
+      x -= sub;
+    }
+    else
+      result[pos] = '0';
+    pos++;
+    sub /= 2;
+  }
+  */
+  
+  return result;
+}
Index: /trunk/src/lib/network/converter.h
===================================================================
--- /trunk/src/lib/network/converter.h	(revision 6139)
+++ /trunk/src/lib/network/converter.h	(revision 6139)
@@ -0,0 +1,38 @@
+/*!
+ * @file converter.h
+ *  Is able to convert int to byte-array and vice versa
+ */
+ 
+#ifndef _CONVERTER
+#define _CONVERTER
+
+/* include this file, it contains some default definitions */
+#include "netdefs.h"
+
+/* include base_object.h since all classes are derived from this one */
+#include "base_object.h"
+
+/* The size of an int in byte */
+#define INTSIZE 4
+
+/*!
+ * a class that can convert int to byte-array and vice versa
+ */
+class Converter: public BaseObject
+{
+  public:
+    static byte* intToByteArray(int x);
+    static int byteArrayToInt(byte* a);
+    
+    //byte* floatToByteArray(float x);
+    //float byteArrayToFloat(byte[] a);
+    
+    //Test
+    static char* floatToBinString(float x);
+    
+  private:
+    Converter();
+    ~Converter();
+};
+
+#endif /*_CONVERTER*/
Index: /trunk/src/lib/network/handshake.cc
===================================================================
--- /trunk/src/lib/network/handshake.cc	(revision 6139)
+++ /trunk/src/lib/network/handshake.cc	(revision 6139)
@@ -0,0 +1,196 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: christoph
+   co-programmer:
+*/
+
+
+/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
+   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
+*/
+#define DEBUG_MODULE_NETWORK
+
+#include "handshake.h"
+
+Handshake::Handshake( bool server, int clientId, int networkGameManagerId )
+{
+  /* set the class id for the base object */
+  this->setClassID(CL_HANDSHAKE, "Handshake");
+
+  this->setIsServer(server);
+  this->clientId = clientId;
+  this->networkGameManagerId = networkGameManagerId;
+  this->state = 0;
+  this->isOk = false;
+  this->setOwner(0);
+
+  PRINTF(5)("Handshake created clientId = %d\n", clientId);
+}
+
+void Handshake::writeBytes( const byte * data, int length )
+{
+  PRINTF(5)("Handshake::writeBytes states = %d %d %d %d (%d)\n", hasState( HS_RECVD_INIT ), hasState( HS_RECVD_VER ), hasState( HS_RECVD_HID ), hasState( HS_COMPLETED ), state);
+
+  if ( hasState( HS_COMPLETED ) )
+       return;
+
+  if ( !hasState( HS_RECVD_INIT ) )
+  {
+    if ( length != _INITIAL_DATA_LENGTH )
+    {
+      PRINTF(0)("initial packet has wrong size %d instead of %d\n", length, _INITIAL_DATA_LENGTH);
+      setState( HS_COMPLETED );
+      return;
+    }
+
+    if ( strncmp((char*)data, _INITIAL_DATA, length) )
+    {
+      PRINTF(0)("initial packed does not match\n");
+      setState( HS_COMPLETED );
+      return;
+    }
+
+    setState( HS_RECVD_INIT );
+    PRINTF(0)("got valid initial packet from client %d\n", clientId);
+    return;
+  }
+
+  if ( hasState( HS_RECVD_INIT ) && !hasState( HS_RECVD_VER ) )
+  {
+    if ( length != _ORXONOX_VERSION_LENGTH )
+    {
+      PRINTF(0)("version number packet has wrong size %d instead of %d\n", length, _ORXONOX_VERSION_LENGTH);
+      setState( HS_COMPLETED );
+      return;
+    }
+
+    if ( strncmp((char*)data, _ORXONOX_VERSION, length) )
+    {
+      PRINTF(0)("versions do not match\n");
+      setState( HS_COMPLETED );
+      return;
+    }
+
+    setState( HS_RECVD_VER );
+
+    PRINTF(0)("client %d's version does match\n", clientId);
+    return;
+  }
+
+  if ( !isServer() && hasState( HS_RECVD_VER ) && !hasState( HS_RECVD_HID ) )
+  {
+    if ( length != 2 )
+    {
+      PRINTF(0)("hostID packet has wrong size %d instead of %d\n", length, 1);
+      setState( HS_COMPLETED );
+      return;
+    }
+
+    setState( HS_COMPLETED );
+    setState( HS_RECVD_HID );
+    this->isOk = true;
+    this->newHostId = data[0];
+    this->newNetworkGameManagerId = data[1];
+
+    if ( newHostId == 0 )
+    {
+      setState( HS_WAS_REJECT );
+      isOk = false;
+      PRINTF(0)("Server did not accept handshake!\n");
+    }
+    else
+    {
+      PRINTF(0)("got my hostID: %d and networkGameManagerId: %d\n", newHostId, newNetworkGameManagerId);
+    }
+    return;
+  }
+
+}
+
+int Handshake::readBytes( byte * data, int maxLength, int * reciever )
+{
+  PRINTF(5)("Handshake::readBytes states = %d %d %d %d (%d)\n", hasState( HS_SENT_INIT ), hasState( HS_SENT_VER ), hasState( HS_SENT_HID ), hasState( HS_COMPLETED ), state);
+
+  if ( hasState( HS_COMPLETED ) )
+    return 0;
+
+  if ( !hasState( HS_SENT_INIT ) )
+  {
+    if ( maxLength < _INITIAL_DATA_LENGTH )
+    {
+      PRINTF(0)("buffer too small for _INITIAL_DATA");
+      setState( HS_COMPLETED );
+      return 0;
+    }
+
+    setState( HS_SENT_INIT );
+    memcpy(data, _INITIAL_DATA, _INITIAL_DATA_LENGTH);
+    if ( this->isServer() )
+      *reciever = clientId;
+    return _INITIAL_DATA_LENGTH;
+  }
+
+  if ( hasState( HS_RECVD_INIT ) && hasState( HS_SENT_INIT ) && !hasState( HS_SENT_VER ) )
+  {
+    if ( maxLength < _ORXONOX_VERSION_LENGTH )
+    {
+      PRINTF(0)("buffer too small for version number");
+      setState( HS_COMPLETED );
+      return 0;
+    }
+
+    setState( HS_SENT_VER );
+    memcpy(data, _ORXONOX_VERSION, _ORXONOX_VERSION_LENGTH);
+    if ( this->isServer() )
+      *reciever = clientId;
+    return _ORXONOX_VERSION_LENGTH;
+  }
+
+  if ( isServer() && hasState( HS_RECVD_VER) && hasState( HS_SENT_VER ) && !hasState( HS_SENT_HID ) )
+  {
+    if ( maxLength < 2 )
+    {
+      PRINTF(0)("buffer too small for ID");
+      setState( HS_COMPLETED );
+      return 0;
+    }
+
+    setState( HS_SENT_HID );
+    setState( HS_COMPLETED );
+
+    if ( hasState( HS_DO_REJECT ) )
+    {
+      isOk = false;
+      //memcpy(data, (byte*)0, 4);
+      data[0] = 0;
+    }
+    else
+    {
+      isOk = true;
+      //memcpy(data, &clientId, 4);
+      data[0] = (byte)clientId;
+      data[1] = (byte)networkGameManagerId;
+    }
+    *reciever = clientId;
+    return 2;
+  }
+
+  return 0;
+}
+
+void Handshake::writeDebug( ) const
+{
+}
+
+void Handshake::readDebug( ) const
+{
+}
Index: /trunk/src/lib/network/handshake.h
===================================================================
--- /trunk/src/lib/network/handshake.h	(revision 6139)
+++ /trunk/src/lib/network/handshake.h	(revision 6139)
@@ -0,0 +1,64 @@
+/*!
+ * @file network_stream.h
+ *  implementation of a network pipe
+ */
+
+#ifndef _HANDSHAKE
+#define _HANDSHAKE
+
+#include "base_object.h"
+#include "synchronizeable.h"
+
+#define _INITIAL_DATA "orxonox"
+#define _INITIAL_DATA_LENGTH 7
+
+#define _ORXONOX_VERSION "\x00\x00\x00\x01"
+#define _ORXONOX_VERSION_LENGTH 4
+
+typedef enum HandshakeState {
+  HS_SENT_INIT  = 0x00000001,
+  HS_RECVD_INIT = 0x00000002,
+  HS_SENT_VER   = 0x00000004,
+  HS_RECVD_VER  = 0x00000008,
+  HS_SENT_HID   = 0x00000010,
+  HS_RECVD_HID  = 0x00000020,
+  HS_COMPLETED  = 0x00000040,
+
+  HS_DO_REJECT  = 0x00010000,
+  HS_WAS_REJECT = 0x00020000,
+
+  NUM_STATES
+};
+
+class Handshake : public Synchronizeable
+{
+  public:
+    Handshake(bool server, int clientId = 0, int networkGameManagerId = 0);
+    inline bool       completed(){ return hasState( HS_COMPLETED ); }
+    inline bool       ok(){ return isOk; }
+    inline int        getHostId(){ return newHostId; }
+    inline int        getNetworkGameManagerId(){ return newNetworkGameManagerId; }
+
+    inline void       doReject(){ setState(HS_DO_REJECT); }
+
+    virtual void      writeBytes(const byte* data, int length);
+    virtual int       readBytes(byte* data, int maxLength, int * reciever);
+    virtual void      writeDebug() const;
+    virtual void      readDebug() const;
+
+  private:
+    int               state;
+    int               clientId;
+    int               networkGameManagerId;
+    int               newHostId;
+    int               newNetworkGameManagerId;
+    bool              isOk;
+
+    inline bool       hasState( int a ){ return (state & a) == a; }
+    inline void       setState( int a ){ state = state | a; }
+    inline void       unsetState( int a ){ state = state & (~a); }
+
+};
+
+
+#endif
Index: /trunk/src/lib/network/network_game_manager.cc
===================================================================
--- /trunk/src/lib/network/network_game_manager.cc	(revision 6139)
+++ /trunk/src/lib/network/network_game_manager.cc	(revision 6139)
@@ -0,0 +1,123 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Wuest
+   co-programmer: ...
+*/
+
+
+/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
+   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
+*/
+#define DEBUG_MODULE_NETWORK
+
+/* include your own header */
+#include "network_game_manager.h"
+
+
+/* using namespace std is default, this needs to be here */
+using namespace std;
+
+/*!
+ * Standard constructor
+ */
+NetworkGameManager::NetworkGameManager()
+{
+  /* set the class id for the base object */
+  this->setClassID(CL_ENTITY_MANAGER, "EntityManager");
+}
+
+/*!
+ * Standard destructor
+ */
+NetworkGameManager::~NetworkGameManager()
+{
+}
+
+
+void NetworkGameManager::writeBytes(const byte* data, int length)
+{
+}
+
+int NetworkGameManager::readBytes(byte* data, int maxLength, int * reciever)
+{
+}
+
+void NetworkGameManager::writeDebug() const
+{
+}
+
+void NetworkGameManager::readDebug() const
+{
+}
+
+
+/*!
+ * Checks whether this is connected to a server or a client
+ * and afterwards creates the needed entity if possible
+ * @param classID: The ID of the class of which an entity should be created
+ */
+void NetworkGameManager::createEntity(int classID)
+{
+}
+
+/*!
+ * Checks whether this is connected to a server or a client
+ * and afterwards removes the specified entity
+ * @param uniqueID: The ID of the entity object which should be removed
+ */
+void NetworkGameManager::removeEntity(int uniqueID)
+{
+}
+
+
+
+/*!
+ * Creates the needed entity on the server if possible
+ * @param classID: The ID of the class of which an entity should be created
+ */
+void NetworkGameManager::requestCreateEntity(int classID)
+{
+}
+
+/*!
+ * Removes the specified entity on the server
+ * @param uniqueID: The ID of the entity object which should be removed
+ */
+void NetworkGameManager::requestRemoveEntity(int uniqueID)
+{
+}
+
+/*!
+ * Creates the needed entity if possible
+ * This function is called if this is a server
+ * @param classID: The ID of the class of which an entity should be created
+ */
+void NetworkGameManager::executeCreateEntity(int classID)
+{
+}
+
+/*!
+ * Removes the specified entity
+ * This function is called if this is a server
+ * @param uniqueID: The ID of the entity object which should be removed
+ */
+void NetworkGameManager::executeRemoveEntity(int uniqueID)
+{
+}
+
+/*!
+ * Checks whether it is possible to create an entity of a given class
+ * @return: true if the entity can be created, false otherwise
+ */
+bool NetworkGameManager::canCreateEntity(int classID)
+{
+}
Index: /trunk/src/lib/network/network_game_manager.h
===================================================================
--- /trunk/src/lib/network/network_game_manager.h	(revision 6139)
+++ /trunk/src/lib/network/network_game_manager.h	(revision 6139)
@@ -0,0 +1,89 @@
+/*!
+ * @file entity_manager.h
+ *  Manages creation and destruction of entities
+ */
+
+#ifndef _NETWORK_GAME_MANGER
+#define _NETWORK_GAME_MANAGER
+
+/* include this file, it contains some default definitions */
+#include "netdefs.h"
+
+/* include base_object.h since all classes are derived from this one */
+#include "synchronizeable.h"
+
+
+
+/**
+ * protocol definition
+ *
+ *  CREATE_ENTITY:      CLASS_ID, UNIQUE_ID, OWNER
+ *  REMOVE_ENTITY:      UNIQUE_ID
+ *
+ *  CREATE_ENTITY_LIST: NUMBER, [CLASS_ID, UNIQUE_ID, OWNER][0..NUMBER]
+ *  REMOVE_ENTITY_LIST: NUMBER, [UNIQUE_ID][0..NUMBER]
+ *
+ *  REQUEST_CREATE:     CLASS_ID
+ *  REQUEST_REMOVE:     UNIQUE_ID
+ *
+ *  REQUEST_SYNC:       UNIQUE_ID
+ *  REQUEST_SYNC_LIST:  NUMBER, [UNIQUE_ID][0..NUMBER]
+ *
+ *
+ */
+
+
+
+
+
+
+
+
+
+
+/*!
+ * a class that can create and remove entities
+ */
+class NetworkGameManager: public Synchronizeable
+{
+  public:
+    NetworkGameManager();
+    ~NetworkGameManager();
+
+    virtual void writeBytes(const byte* data, int length);
+    virtual int readBytes(byte* data, int maxLength, int * reciever);
+    virtual void writeDebug() const;
+    virtual void readDebug() const;
+
+    void createEntity(int classID);
+    void createEntityList(int* classIDList);
+    void removeEntity(int uniqueID);
+    void removeEntityList(int* uniqueIDList);
+
+    void sync(int uniqueID);
+    void syncList(int* uniqueIDList);
+
+
+  private:
+    void requestCreateEntity(int classID);
+    void executeCreateEntity(int classID);
+    void requestCreateEntityList(int* classIDList);
+    void executeCreateEntityList(int* classIDList);
+
+    void requestRemoveEntity(int uniqueID);
+    void executeRemoveEntity(int uniqueID);
+    void requestRemoveEntityList(int* uniqueIDList);
+    void executeRemoveEntityList(int* uniqueIDList);
+
+
+
+    bool canCreateEntity(int classID);
+
+
+
+  private:
+    byte*          inBuffer;
+    byte*          outBuffer;
+};
+
+#endif /*_ENTITY_MANGER*/
Index: /trunk/src/lib/network/network_manager.cc
===================================================================
--- /trunk/src/lib/network/network_manager.cc	(revision 6138)
+++ /trunk/src/lib/network/network_manager.cc	(revision 6139)
@@ -50,4 +50,5 @@
   this->tmpStream = NULL;
   this->hostID = -1;
+  this->bGameServer = false;
 
   PRINTF(0)("NetworkManager created\n");
@@ -95,5 +96,5 @@
   }
 
-  this->tmpStream = new NetworkStream(ipAddress, NET_CLIENT);
+  this->tmpStream = new NetworkStream(ipAddress);
   return 1;
 }
@@ -106,5 +107,6 @@
 int NetworkManager::createServer(unsigned int port)
 {
-  this->tmpStream = new NetworkStream(port, NET_SERVER);
+  this->tmpStream = new NetworkStream(port);
+  this->bGameServer = true;
   SDL_Delay(20);
   return 1;
@@ -120,5 +122,6 @@
 {
   /* creating a new network stream, it will register itself automaticaly to the class list */
-  this->tmpStream = new NetworkStream(address, sync, NET_CLIENT);
+  this->tmpStream = new NetworkStream(address);
+  this->tmpStream->connectSynchronizeable(sync);
 }
 
@@ -132,5 +135,7 @@
   PRINTF(0)("Create a new server socket\n");
   /* creating a new network stream, it will register itself automaticaly to the class list */
-  this->tmpStream = new NetworkStream(port, sync, NET_SERVER);
+  this->tmpStream = new NetworkStream(port);
+  this->tmpStream->connectSynchronizeable(sync);
+  this->bGameServer = true;
 }
 
Index: /trunk/src/lib/network/network_manager.h
===================================================================
--- /trunk/src/lib/network/network_manager.h	(revision 6138)
+++ /trunk/src/lib/network/network_manager.h	(revision 6139)
@@ -45,19 +45,22 @@
     void setHostID(int id);
     /** Returns the hostID @return The hostID of the object */
-    inline int getHostID() { return this->hostID; };
+    inline int getHostID() { return this->hostID; }
+    inline bool isGameServer() { return this->bGameServer; }
 
-  private:
+
     void connectSynchronizeable(Synchronizeable& sync);
     void synchronize();
 
+  private:
     NetworkManager();
 
 
   private:
-    const std::list<BaseObject*>*    netStreamList;            // list with refs to all network streams
-    const std::list<BaseObject*>*    syncList;                 // list of synchronizeables
-    static NetworkManager* singletonRef;           //!< Pointer to the only instance of this Class
-    NetworkStream*         tmpStream;              //!< FIXME: this is only for testing purposes
-    int hostID;                                    //!< The Host-ID of the Manager
+    const std::list<BaseObject*>*    netStreamList;           // list with refs to all network streams
+    const std::list<BaseObject*>*    syncList;                // list of synchronizeables
+    static NetworkManager*           singletonRef;            //!< Pointer to the only instance of this Class
+    NetworkStream*                   tmpStream;               //!< FIXME: this is only for testing purposes
+    int                              hostID;                  //!< The Host-ID of the Manager
+    bool                             bGameServer;             //!< true if it is a server
 
 };
